#include "global.h"

/* Masses */
#define M_BIG 8000.0
#define M_MED 4.0
#define M_SMALL 1.0
#define M_ENEMY 1.0


  extern Objtype obj[LASTOBJ+1];
  extern int shapesize[LASTSHAPE+1];
  extern ShipType ship[MAXPLAYERS+1];
  extern VirtualType virtual;
  extern int LASTPLAYER,SCROLL;
  extern int numpairs[LASTSHAPE+1];
  extern DeviceType device[MAXPLAYERS+1];
  extern Boom  blist;
  extern PolarPair shapes[LASTSHAPE+1][MAXPAIRS];
  extern PhysicalType physical[MAXPLAYERS+1];

/*****************************************************************************/
/* This function will intialize the shapes of the bullets and damage caused by
   an asteroid */

 initobj()
{ int i;
  extern Objtype obj[LASTOBJ+1]; 
  ship[0].damage = 25;
  for (i = 0; i < LASTOBJ+1; i++)
    { obj[i].rot = 0;
      obj[i].rotvel = 0;
      obj[i].owner = 1;
      obj[i].alive = 0;
    }
  for (i = 0; i < LASTAST; i++)
    { obj[i].shape = ASTSHAPE1;
    }


  for (i = FIRSTPLAYER ; i <= LASTPLAYER; i++) {
    obj[i].shape = i * 2  + SHIPSHAPE -1;
    /*##typechange    obj[i].mass = ship[i].mass; */
  }
  obj[ENEMY].shape = SHIPSHAPE + 1; 
  obj[ENEMY].mass = M_ENEMY;
  obj[ENEMYBUL].shape = ENBULSH;
  obj[ENEMYBUL].mass = M_BULLET;
  for (i = FBUL; i < LASTBUL+1; i++)
    { obj[i].shape = BULSHAPE;
      obj[i].mass = M_BULLET;
    } 
}

/*****************************************************************************/
/* This will return the distance between the two passed objects */
double* distance(i,j) 
     int i,j;
{ double dx,dy,temp;
  int idx,idy;
  
  idx = obj[i].x - obj[j].x;
  idy = obj[i].y - obj[j].y;
  dx = (double) idx;
  dy = (double) idy;
  temp = sqrt(dx*dx + dy*dy);
#if 0
  printf("distance is %f \n",(float)temp);
#endif
  return &temp;
}

/*****************************************************************************/
/* This function will remove all asteriods from the simulation and
    create asteroids based on the passed level.  The higher the
    level, the more asteroids that will be created */

makeasts(level)
{ int i,j;
  extern Objtype obj[LASTOBJ+1];
  extern int numasts, rndint;
  extern double speedscale; 
  unsigned char a;


  for (i = AST; i <= AST + level - 1; i++)  /* Asteroids:     */
  {

/* obj[i].x = virtual.x2 / 2.0 ;
  obj[i].y = virtual.y2 /2.0;

*/
    obj[i].x = (double)random(rndint)/(double)INT_MAX * virtual.x2;
    obj[i].y = (double)random(rndint)/(double)INT_MAX * virtual.y2;
    
    obj[i].rotvel = (double)random(rndint)/(double)INT_MAX;
    obj[i].rot = 0.51;


    obj[i].xvel = (double)random(rndint)/(double)INT_MAX*3.0 - 1.5;
    obj[i].yvel = (double)random(rndint)/(double)INT_MAX*3.0 - 1.5;



    obj[i].shape = ASTSHAPE1;
    obj[i].mass = M_BIG;
    obj[i].alive = 1;
    obj[i].time = 1;
  }
  numasts = i;
}

/*****************************************************************************/
int collide(player,i, j)  /* Returns non-zero if i collided with j  */
      /* Ship must be j!  (See below)     */
  int i, j;
{ extern Objtype obj[LASTOBJ+1];
  extern int shapesize[LASTSHAPE+1];
  
  double  mi, mj,       /* Slopes of lines  */
    ix1, ix2, iy1, iy2, jx1, jx2, jy1, jy2, /* Endpoints  */
    roti, rotj,
    xcross, ycross,   /* coord of intersection  */
    z;
  int diff, xd, yd,
    a, b,
    shapei, shapej;
        if (i == j) return 0;

  xd = obj[i].x - obj[j].x;
  yd = obj[i].y - obj[j].y;
  diff = sqrt((double)(xd*xd + yd*yd));
  shapei = obj[i].shape; shapej = obj[j].shape;

  if (diff < (shapesize[shapei] + shapesize[shapej]))
  {   /* If both are round objects, approximation is good */
      if (shapei < SHIPSHAPE && shapej < SHIPSHAPE) return 1;
      if (j == player && ship[player].shield_on) return 1;  /* Ship always j */
      roti = obj[i].rot; rotj = obj[j].rot;
      ix1 = (double) obj[i].x; iy1 = (double) obj[i].y;
      for (a = 1; a < numpairs[shapei]; a++)
      { ix2 = ix1 + (double) shapes[shapei][a].length *
      cos(shapes[shapei][a].angle + roti);
    iy2 = iy1 + (double) shapes[shapei][a].length  *
      sin(shapes[shapei][a].angle + roti);
    if (ix1 == ix2)
       { 
#ifdef DEBUG
         printf("\nif1 = if2"); 
#endif
         return 1;} /* Easy way out */
    mi = (iy2-iy1)/(ix2-ix1);
    z = mi*ix1;
    jx1 = (double) obj[j].x; jy1 = (double) obj[j].y;
    for (b = 1; b < numpairs[shapej]; b++)
    { jx2 = jx1 + (double) shapes[shapej][b].length *
         cos(shapes[shapej][b].angle + rotj);
      jy2 = jy1 + (double) shapes[shapej][b].length *
         sin(shapes[shapej][b].angle + rotj);
      if (jx1 == jx2)
      { ycross = ix1 + (jx1-ix1)*mi;
        if ((jx1-ix1) * (ix2-jx1) >= 0 &&
          (ycross-jy1)*(jy2-ycross) >= 0)
          return 1;
        else jx2 += .0001;  /* Avoid divide by 0 */
      }
      mj = (jy2-jy1)/(jx2-jx1);
      if (mj == mi) goto Loopend; /* Parallel lines */
      xcross = (iy1 - jy1 + mj*jx1 - z) / (mj - mi);
      if ((xcross-ix1) * (ix2-xcross) > 0
        && (xcross-jx1) * (jx2-xcross) > 0) return 1;
Loopend:    jx1 = jx2; jy1 = jy2;
    }
    ix1 = ix2; iy1 = iy2;
  }   }
  return 0;
}

/*****************************************************************************/
blastpair(i, j)   /* Generate random velocity vector v. */
  int i, j ;  /* Add v to i, -v to j.     */
{ extern int rndint;
  extern Objtype obj[LASTOBJ+1];
  unsigned char c;  /* for rand */
  double vx, vy;
  c = rand(rndint);
/*  c = 4 - c>>5; if you need angles from -3 to 4   */
  c>>2;   /* possibly save some time on sin/cos */
  vx = cos((double) c); vy = sin((double) c);
  obj[i].xvel = obj[i].xvel + vx;
  obj[i].yvel = obj[i].yvel + vy;
  obj[j].xvel = obj[j].xvel - vx;
  obj[j].yvel = obj[j].yvel - vy;
  obj[i].rotvel = obj[i].rotvel + .05;
  obj[j].rotvel = obj[j].rotvel - .05;
}

/* dot product of 2 vectors */
#define dot(i,j)  (i.x*j.x + i.y*j.y)
/* rotational inertia (constant eliminated) of obj. i */
#define rotinert(i) (double) (obj[i].mass*shapesize[obj[i].shape]*shapesize[obj[i].shape])

/*****************************************************************************/
/* cause two objects to collide elastically */
bounce(i, j)
     int  i,j;
{
  double  rotrat, temp;
  extern  Objtype obj[LASTOBJ+1];
  Vector  vi, vj,   /* velocity of objs i, j    */
  ij,   /* vector from center of i to center of j */
  vi_ij, vj_ij, /* velocity of obj along vector ij  */
  vipij, vjpij, /* velocity perpendicular to ij   */
  vi_ijf, vj_ijf; /* post-collision velocity along ij */
  
  vi.x = obj[i].xvel; vi.y = obj[i].yvel;
  vj.x = obj[j].xvel; vj.y = obj[j].yvel;
  ij.x = obj[j].x - obj[i].x; ij.y = obj[j].y - obj[i].y;
  ij.mag = sqrt(ij.x*ij.x + ij.y*ij.y);
  /*
     Calculate velocities projected onto ij;
     vi_ij = vi*cos(a) = (vi dot ij) / |ij|   */
  vi_ij.mag = dot(vi, ij) / ij.mag;
  vi_ij.x = (ij.x * vi_ij.mag) / ij.mag;
  vi_ij.y = (ij.y * vi_ij.mag) / ij.mag;
  vj_ij.mag = dot(vj, ij) / ij.mag;
  vj_ij.x = (ij.x * vj_ij.mag) / ij.mag;
  vj_ij.y = (ij.y * vj_ij.mag) / ij.mag;
  if (vi_ij.mag - vj_ij.mag < 0)  
    /* Objs moving away from each other -
       Since objs are round (at least when bouncing), this means
       they are moving away from each other already.  */
    return;
  /*
     Calculate component of velocities perpendicular to ij:
     |vipij| = |vi|*sin(a) = |vi x ij| / |ij|
     Same as
     |vipij| = |vi|*cos(pi/2 - a) = (vi dot (perp. to ij)) / |ij| */
  temp = vi.y*ij.x - vi.x*ij.y; /* - (cross product when 3rd coord is 0)*/
  temp /= (ij.mag*ij.mag);
  vipij.x = -ij.y*temp; vipij.y = ij.x*temp;
  temp = (vj.x*ij.y - vj.y*ij.x) / (ij.mag*ij.mag);
  vjpij.x = -ij.y*temp; vjpij.y = ij.x*temp;
  /*
     Calculate the linear elastic collision along ij:
     mass(i)*vi_ij + mass(j)*vj_ij = mass(i)*vi_ijf + mass(j)*vj_ijf
     vi_ij + vi_ijf = vj_ij + vj_ijf  (derived by dividing equation
     for conservation of kinetic energy by eq. for cons. of momentum) */
  temp = obj[i].mass/obj[j].mass;
  vj_ijf.x = (temp * (2*vi_ij.x - vj_ij.x) + vj_ij.x) / (1 + temp);
  vj_ijf.y = (temp * (2*vi_ij.y - vj_ij.y) + vj_ij.y) / (1 + temp);
  vi_ijf.x = vj_ijf.x + vj_ij.x - vi_ij.x;
  vi_ijf.y = vj_ijf.y + vj_ij.y - vi_ij.y;
  /*
     Now, given vi_ijf and vj_ijf, add them to the perpendicular
     components to get final velocity vectors   */
  obj[i].xvel = vi_ijf.x + vipij.x;
  obj[i].yvel = vi_ijf.y + vipij.y;
  obj[j].xvel = vj_ijf.x + vjpij.x;
  obj[j].yvel = vj_ijf.y + vjpij.y;
  /*
     Now calculate rotational velocity exchange */
  rotrat = rotinert(i)/rotinert(j);
  temp = rotrat * (2*obj[i].rotvel - obj[j].rotvel) / (1+rotrat);
  obj[i].rotvel = temp + obj[j].rotvel - obj[i].rotvel;
  obj[j].rotvel = temp;
}

/*****************************************************************************/
/* boom, movebooms, drawbooms all by Peter Phillips */
boom(ob, particles, duration)
int ob;
int particles;
int duration;
{ extern int rndint;
  int i;
  unsigned int r1, r2;
  Boom b;
  double x, y;
  double angle, length;


  b = (Boom) malloc(sizeof(struct _Boom));
  b->dur = duration;
  b->part = particles;
  x = obj[ob].x;
  y = obj[ob].y;
/*  printf("%i %f %f\n",ob,(float)x,(float)y); */
  for (i = 0; i < particles; i++) {
    r1 = (rand(rndint) >> 2) % 100;
    r2 = (rand(rndint) >> 2) % 7;

    b->bcoord[i][0] = x;
    b->bcoord[i][1] = y;
    angle = r1 * pi / 50.0;
    length = 3 + r2;
    b->bvec[i][0] = cos(angle) * length + obj[ob].xvel;
    b->bvec[i][1] = sin(angle) * length + obj[ob].yvel;

  }
  b->next = blist;
  blist = b;
}

/*****************************************************************************/
/* move the various booms that are active */
movebooms()
{
  int i;
  Boom b, prevb;

  prevb = NULL;
  b = blist;
  while (b != NULL) {
    b->dur--;
    if (b->dur < 0) { /* delete this boom */
      Boom temp;

      temp = b;
      if (prevb == NULL) {
        blist = b->next;
      } else {
        prevb->next = b->next;
      }
      b = b->next;
      free(temp);
    } else {  /* move boom, advance list */
      for (i = 0; i < b->part; i++) {
        b->bcoord[i][0] += b->bvec[i][0];
        b->bcoord[i][1] += b->bvec[i][1];
/*        printf("%f %f \n",(float)b->bcoord[i][0],(float)b->bcoord[i][1]); */
      }
      prevb = b;
      b = b->next;
    }
  }
}

/*****************************************************************************/
/* Draw the various booms */
drawbooms(disp, window, gc1, gc2, gc3,player)
     Display *disp;
     Drawable window;
     GC gc1, gc2, gc3;
     int player;

{

  int i;
  Boom b;
  static XPoint figure[BMAX];
  static int boomcolor;

  b = blist;

  while (b != NULL) {
    for (i = 0; i < b->part; i++) {

      if (SCROLL) {
        figure[i].x = (short) ((b->bcoord[i][0] - physical[player].x) * 
                               device[player].scalex);
    figure[i].y = (short) ((b->bcoord[i][1] - physical[player].y) * 
                           device[player].scaley); 
      }
      else{
        figure[i].x = (short) ((b->bcoord[i][0]) * device[player].scalex);
        figure[i].y = (short) ((b->bcoord[i][1]) * device[player].scaley);

      }
      
    }
    
    if (boomcolor == 1) {
      boomcolor = 2;
      /***### fix me */
      XDrawPoints(disp, window, gc1, figure, b->part, CoordModeOrigin);
    } else if (boomcolor ==2){
      boomcolor = 3;
      XDrawPoints(disp, window, gc2, figure, b->part, CoordModeOrigin);
    } else {
      boomcolor = 1;
      XDrawPoints(disp, window, gc3, figure, b->part, CoordModeOrigin);    
    }
  
    b = b->next;
  }
}

/*****************************************************************************/
deletebooms() /* delete all booms */
{ Boom b;

  b = blist;
  while (b != NULL)
  { b->dur = 0;
    b = b->next;
} }

/*****************************************************************************/
/* This function will kill the asteriod that is associated with the passed 
   value i.
*/
killast(killer, i)
  int killer, i;    /* i = Asteroid # to kill */
{ extern Objtype obj[LASTOBJ+1];
  extern int numasts;
  int k, na, oldna, player;


  if (obj[i].shape == ASTSHAPE1)
  { 
    obj[i].time--;
    if (!obj[i].time) {
      obj[i].time = 5; /*## 5 should not be hard coded */
      na = nextast();   /* Could put 6 lines in a sub */
      obj[na].x = obj[killer].x + 1;
      obj[na].y = obj[killer].y + 1;
      obj[na].xvel = obj[i].xvel;
      obj[na].yvel = obj[i].yvel;
      obj[na].alive++;
      obj[na].shape = ASTSHAPE3;
      obj[na].mass = M_SMALL;
      obj[i].shape = ASTSHAPE2;
      obj[i].mass = M_MED;

      obj[i].owner = obj[na].owner = 1;
  
      blastpair(killer, na); 
      boom(killer, 30, 12);
      numasts++;
    }
    else {
      boom(killer, 5, 12);

    }

  }
  else if (obj[i].shape == ASTSHAPE2)
  {
    for (k = 0; k < 3; k++)
    { oldna = na;
      na = nextast();
      obj[na].x = obj[i].x;
      obj[na].y = obj[i].y;
      obj[na].xvel = obj[i].xvel;
      obj[na].yvel = obj[i].yvel;
      obj[na].alive++;
      obj[na].shape = ASTSHAPE3;
      obj[na].mass = M_SMALL;
                        obj[na].owner = 1;
      if (k == 1) blastpair(oldna,na);
    }
    obj[i].shape = ASTSHAPE3;
    obj[i].mass = M_SMALL;
    blastpair(na, i);
    boom(i, 20, 10);
    numasts = numasts + 3;
  }
  else if (obj[i].shape == ASTSHAPE3)
  { boom(i, 10, 8);
    obj[i].alive = 0; numasts--; 
      
        }
        else if (i >= FIRSTPLAYER && i <= LASTPLAYER )
    {
            TakeDamage(i,killer);
            printf("This TAKE DAMAGE should not be called\n");
            boom(killer,40,20);

          }
      
  else if (i < MAXPLAYERS) {
    TakeDamage(i,killer);
    boom(killer,40,20);

  }
  else  /* bullet */
  { 
    obj[i].alive = 0;
    boom(killer,40,20);    
  }
}

/*****************************************************************************/
/*#no scroll*/
#define Move_Physical_Window(player) \
/*int player; */\
\
{\
  extern Objtype obj[LASTOBJ+1];\
  extern PhysicalType physical[MAXPLAYERS+1];\
\
  /* the position of the physical window is usually the centered around the\
     player.\
  */\
\
  /* Check all four boundries to see if the physical is at the boundry of the\
     virtual window */\
\
  /* move the window, assumming it is inside the virtual window */\
\
  physical[player].x = (int)obj[player].x - physical[player].width/2;\
  physical[player].y = (int)obj[player].y - physical[player].height/2;\
\
\
}

/*****************************************************************************/

/* This function will move all objects in the simulation.  These objects 
   include ships, bullets and asteroids.  After all of the objects have been 
   moved this function checks for collitions between objects and calls the 
   proper function to handle process the collition between the objects.
*/

moveobjs()


{
  extern Objtype obj[LASTOBJ+1];
  extern int ships;
  extern double speedscale;
  int i, j; /* Indexes  */
  double *temp;
  int player,rx,ry;

  movebooms();
  for (i = 0; i < LASTOBJ+1; i++){
    if (obj[i].alive){


/*### make this more readable use more then one temp variable*/
      temp = &obj[i].x;
      *temp = *temp + obj[i].xvel*speedscale;
      if (SCROLL) {
  if (*temp < virtual.x1) obj[i].xvel = obj[i].xvel * -1 ; 
        if (*temp > virtual.width) obj[i].xvel = obj[i].xvel * -1 ; 
  temp = &obj[i].y;

  *temp = *temp + obj[i].yvel*speedscale;
  if (*temp < virtual.y1) obj[i].yvel = obj[i].yvel * -1 ; 

  if (*temp > virtual.height) obj[i].yvel = obj[i].yvel * -1 ; 

     }
      else{
  while (*temp < virtual.x1) *temp = *temp + (double) virtual.width;
  while (*temp > virtual.width) *temp = *temp - (double) virtual.width;
  temp = &obj[i].y;

  *temp = *temp + obj[i].yvel*speedscale;
  while (*temp < virtual.y1) *temp = *temp + virtual.height;
  while (*temp > virtual.height) *temp = *temp - virtual.height;
      }
      obj[i].rot = obj[i].rot + obj[i].rotvel;
    }
  }
  for (i = 0; i < LASTOBJ; i++){
    if (obj[i].alive){ 
      /* Check if object i collides with a ship */
      for (player = FIRSTPLAYER; player <= MAXPLAYERS; player++) {  

        if (obj[player].alive && collide(player,i, player)) {
            bounce(player, i); 
          if ( obj[i].shape == BULSHAPE) {
            /* make the explosion go with the ship */
            obj[i].xvel = obj[player].xvel;
	    obj[i].yvel = obj[player].yvel;
	  }

          TakeDamage(player,i);   
        }
      }
      /* Check if a bullet collides with an asteriod */
      if (i > MAXPLAYERS ) {
        for (j = FBUL; j < LASTBUL+1; j++){
          if (obj[j].alive && collide( 1,i, j)) {

            obj[j].alive = 0; /* Kill the bullet */
            /* Don't have 2 bullets kill same asteroid */
            if (obj[i].alive) killast(j,i);
          }
        }
      }
    }    
   

  }
  if (SCROLL) {
    for (player = FIRSTPLAYER; player <= LASTPLAYER; player++) {  

      Move_Physical_Window(player);
    }
  }
}










